<?php
/**
 *
 * @package MediaWiki
 * @subpackage SpecialPage
 */

/**
 *
 */
require_once("QueryPage.php");

/**
 * SpecialActiveUsers extends QueryPage. It is used to return the users
 * with the most edits in the database.
 * @package MediaWiki
 * @subpackage SpecialPage
 */
class ActiveUsersPage extends QueryPage {

	function getName() {
		return "ActiveUsers";
	}

	/**
	 * 
	 */
	function isExpensive() {
		return true;
	}
	
	function isSyndicated() {
		return false;
	}

	function getSQL() {
		$dbr =& wfGetDB( DB_SLAVE );
		$page = $dbr->tableName( 'page' );
		$name = $dbr->addQuotes( $this->getName() );

	/** Old SQL query
		return "SELECT old_user, old_user_text as type, Count( old_user ) AS value
			FROM text 
			WHERE old_user >0
			GROUP BY old_user"; */

		return "SELECT rev_user, rev_user_text as type, Count(rev_user) as value
			FROM revision
			WHERE rev_user > 0
			GROUP BY rev_user";
	}
	
	function sortDescending() {
		return true;
	}

	function formatResult( $skin, $result ) {
		global $wgLang, $wgContLang;

		$user = null;
		$user =& User::newFromName($result->type);

		if (is_null($user)) {
			return "{$result->type} has {$result->value} edits.";
		}
		else {
			$title = $user->getUserPage();
			# $title = Title::makeTitle( $result->namespace, $result->title );
			$link = $skin->makeLinkObj( $title, $wgContLang->convert( $title->getPrefixedText() ) );
		
			return "<b>{$link}</b> has {$result->value} edits.";
		}
	}
}

/**
 * constructor
 */
function wfSpecialActiveUsers() {
	list( $limit, $offset ) = wfCheckLimits();

	$spp = new ActiveUsersPage();

	return $spp->doQuery( $offset, $limit );
}

?>
